%{
#include <stdio.h>
#include <math.h>

#define YY_DECL int yylex()

#include "calc.tab.h"

%}

%%

[ \t]	; // ignore all whitespace
[0-9]+\.[0-9]+ 	{yylval.fval = atof(yytext); return T_FLOAT;}
[0-9]+		{yylval.ival = atoi(yytext); return T_INT;}
[a-z]		{yylval.ival = *yytext - 'a'; return T_NAME;}
[A-Z]		{yylval.ival = *yytext - 'A'; return T_FUNC;}
\n		{return T_NEWLINE;}
"|"		{return T_BIT_OR;}
"+"		{return T_PLUS;}
"-"		{return T_MINUS;}
"*"		{return T_MULTIPLY;}
"/"		{return T_DIVIDE;}
"**"	{return T_POWER;}
"("		{return T_LEFT;}
")"		{return T_RIGHT;}
"["		{return T_L_BRA;}
"]"		{return T_R_BRA;}
"="		{return T_EQ;}
":="	{return T_DEF;}
"?"		{return T_IF;}
","		{return T_COMMA;}
"<"		{return T_LESSTHAN;}
"PI"	{yylval.fval = M_PI; return T_FLOAT;}
"sin"	{return T_SIN;}
"exit"		{return T_QUIT;}
"quit"		{return T_QUIT;}
"$1"		{return T_DOLLAR1;}

%%
