/*
 * node.c
 */

#include <stdio.h>
#include <stdlib.h>		/* malloc を利用する */

#include "node.h"
#include "calc.tab.h"

/*
 *	ealloc
 *		alloc して、とれなければ error 
 */

static	void	*ealloc ( int size ) {
  void	*p;

  if ( ( p = malloc(size) ) == NULL ) {
	  /* (*) 本来は、エラー処理を行うべき !! */
	  fprintf ( stderr, "Malloc Error\n" );
	  exit(-1);	/* エラーメッセージを出力して、実行終了 */
  }

  return p;
}

#define	xealloc(Type)	((Type *)ealloc(sizeof(Type)))

/*
 *	xealloc(double)
 *		((double *)ealloc(sizeof(double)))
 */


/*
 *	make_node
 *		新しい Node を作成し、その Node のフィールドを初期化して返す
 *			メモリの確保に失敗した場合は Error Exit (最低限度のエラー処理)
 */

Node	*make_node( int type, int length, void *op1, void *op2 ) {

  return make_node3 ( type, length, op1, op2, NULL );
}

Node	*make_node3( int type, int length, void *op1, void *op2, void *op3 ) {
	Node *value = xealloc(Node);

	value -> type = type;
	value -> length = length;
	value -> op1 = op1;
	value -> op2 = op2;
	value -> op3 = op3;

	return value;

}

/*
 * make_int_node
 */

Node	*make_int_node( int value ) {
  int *ip = xealloc(int);

  *ip = value;

  return make_node ( T_INT, 1, ip, NULL );
}

/*
 * make_float_node
 */

Node	*make_float_node( double value ) {
  double *dp = xealloc(double);

  *dp = value;

  return make_node ( T_FLOAT, 1, dp, NULL );
}

/*
 *
 */

void print_number ( Node *node ) {

  switch ( node -> type ) {
  case T_INT:
	printf ( "%d", get_int( node ) );
	break;
  case T_FLOAT:
	printf ( "%f", get_float( node ) );
	break;
  }
}

/*
 *
 */

